'
' ####################
' #####  PROLOG  #####
' ####################
'
' This program solves the problem of the towers of Hanoi.
'
CONSOLE
'
'	IMPORT "xst"				' Standard library : required by most programs
'	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput library

'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

' IMPORT "gdi32"			' gdi32.dll
'	IMPORT "user32"		  ' user32.dll
	IMPORT "kernel32"	  ' kernel32.dll
'	IMPORT "shell32"		' shell32.dll
'	IMPORT "msvcrt"		  ' msvcrt.dll

'
DECLARE FUNCTION Entry ()
DECLARE FUNCTION move_tower (n, from, to)

$$DISK = 28   ' height of tower

FUNCTION Entry ()

  PRINT "> Starting..."

	start = GetTickCount()
	' Move a tower of height n from the first pole to the second pole.
  n_moves = move_tower ($$DISK, 1, 2)
	finish = GetTickCount() - start
  PRINT ">"; n_moves; " moves in "; finish; " ms" 

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

' Function: move_tower
' Purpose : Move a tower from one pole to the other.
' Input   : n    - The height of the tower (number of rings in it).
'           from - The source pole.
'           to   - The target pole.
' Output  : returns n_moves, number of moves.

FUNCTION move_tower (n, from, to)

'	SHARED n_moves

  ' In case of a single ring, just move it from the source to the target.
  IF (n == 1)
'    ? "Move ring [1] from pole no."; from; " to pole no."; to
    RETURN (1)
	END IF

  ' Since the three poles are indexed 1, 2 and 3 we can easily find the index
  ' of the free auxiliary pole using (1 + 2 + 3 = 6): 
  aux = 6 - from - to

  ' Move the top (n-1) rings from the source pole to the auxiliary pole.
  n_moves = move_tower (n - 1, from, aux)

  ' Move the buttom ring from the source pole to the target pole.
'  ? "Move ring ["; n; "] from pole no."; from; " to pole no."; to 
  INC n_moves

  ' Move the top (n-1) rings from the auxiliary pole to the target pole.
  n_moves = n_moves + move_tower (n - 1, aux, to)

  RETURN (n_moves)

END FUNCTION
END PROGRAM