'
'
' ####################
' #####  PROLOG  #####
' ####################

' Get snapshot of currently running processes.

CONSOLE

IMPORT  "xst_s"
IMPORT  "kernel32"

DECLARE FUNCTION  Entry ()

FUNCTION Entry ()

	FUNCADDR pCreateToolhelp32Snapshot (XLONG, XLONG)
	FUNCADDR pProcess32First (XLONG, XLONG)
	FUNCADDR pProcess32Next (XLONG, XLONG)
	SLONG f, hSnap
	STRING sname
	PROCESSENTRY32 proc


	dllName$ = "Kernel32.dll"		'name of DLL file containing _SomeFunction@8

	CreateToolhelp32Snapshot$ = "CreateToolhelp32Snapshot"		'name exported by DLL

	libHandle = LoadLibraryA (&dllName$)		'load the DLL and return a handle to it
	IFZ libHandle THEN
		PRINT "DLLNotFound"
		QUIT (1)
	END IF

	' CreateToolhelp32Snapshot
	pCreateToolhelp32Snapshot = GetProcAddress (libHandle, &CreateToolhelp32Snapshot$)		'address of the function
	IFZ pCreateToolhelp32Snapshot THEN
		PRINT "FunctionNotFound"
		QUIT (2)
	END IF

	' Process32First
	pProcess32First = GetProcAddress (libHandle, &"Process32First")		'address of the function
	IFZ pProcess32First THEN QUIT (2)

	' Process32Next
	pProcess32Next = GetProcAddress (libHandle, &"Process32Next")		'address of the function
	IFZ pProcess32Next THEN QUIT (2)

	hSnap = @pCreateToolhelp32Snapshot ($$TH32CS_SNAPPROCESS, 0)		'execute the function
	IF hSnap < 1 THEN RETURN
	proc.dwSize = SIZE (proc)
	
	' Iterate through the processes
	f = @pProcess32First (hSnap, &proc)		'execute the function
	DO WHILE f
		sname = proc.szExeFile		'name of the process
		PRINT sname
		f = @pProcess32Next (hSnap, &proc)		'execute the function
	LOOP

	' Do not forget to clean up the snapshot object.
	CloseHandle (hSnap)
	CloseHandle (libHandle)

	a$ = INLINE$ ("process ended press ENTER")
END FUNCTION
END PROGRAM
